diff --git a/core/src/aos_shell.c b/core/src/aos_shell.c
index 2fb9cb4..d3974e4 100644
--- a/core/src/aos_shell.c
+++ b/core/src/aos_shell.c
@@ -712,291 +1065,449 @@ static int _strccmp(const char *str1, const char *str2, bool cs, size_t* n, char
 }
 
 /**
+ * @brief   Alters all intermediate NUL bytes in a string to spaces.
+ *
+ * @param[in] string  The string to be handled.
+ * @param[in] length  Length of the string.
+ *
+ * @return  Detected Length of the actual content of the string.
+ */
+static size_t _restoreWhitespace(char* string, size_t length)
+{
+  aosDbgCheck(string != NULL || length == 0);
+
+  // local variables
+  size_t c = length;
+
+  // seach for first non-NUL byte from the back
+  while (c > 0) {
+    --c;
+    if (string[c] != '\0') {
+      // store the detected length of the content
+      length = ++c;
+      break;
+    }
+  }
+
+  // iterate further and replace all encountered NUL bytes by spaces
+  while (c > 0) {
+    --c;
+    if (string[c] == '\0') {
+      string[c] = ' ';
+    }
+  }
+
+  return length;
+}
+
+/**
+ * @brief   Performs required actions before an imminent modiifcation (character input, deletion or autofill).
+ * @details This functions checks the current status and clears or copies entries in the input buffer as required.
+ *          Status information (runtime data) is altered accordingly as well.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ *
+ * @return    Pointer to the current entry in the input buffer.
+ */
+static char* _prepare4Modification(aos_shell_t* shell, runtimedata_t* rdata)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+
+  char* line = _getCurrentEntry(shell, rdata);
+
+  // cleared preview
+  if (rdata->buffer.selected == 0) {
+    // reset the current entry if required
+    if (rdata->buffer.edited != 0) {
+      memset(line, '\0', shell->input.linewidth * sizeof(char));
+    }
+    // set the current entry as the selected one and mark it as edited
+    rdata->buffer.selected = 1;
+    rdata->buffer.edited = 1;
+  }
+  // current entry
+  else if (rdata->buffer.selected == 1) {
+    // mark current entry as edited
+    rdata->buffer.edited = 1;
+  }
+  // preview of historic entry
+  else if (rdata->buffer.selected > 1) {
+    // copy the selected entry before modification if required
+    if (rdata->buffer.selected!= rdata->buffer.edited) {
+      memcpy(line, _getSelectedEntry(shell, rdata), shell->input.linewidth * sizeof(char));
+    }
+    // mark the selected entry as edited
+    rdata->buffer.edited = rdata->buffer.selected;
+  }
+
+  return line;
+}
+
+/**
  * @brief   Read input from a channel as long as there is data available.
  *
- * @param[in]   shell     Pointer to the shell object.
- * @param[in]   channel   The channel to read from.
- * @param[out]  exec      Optional pointer to a flag, which indicates, whether a command shall be executed.
+ * @param[in]     shell     Pointer to the shell object.
+ * @param[in,out] rdata     Pointer to a runtime data object.
+ * @param[in]     channel   The channel to read from.
  *
- * @return  Number of read characters.
+ * @return  Number of characters read.
  */
-static int _readChannel(aos_shell_t* shell, AosShellChannel* channel, bool* execute)
+static size_t _readChannel(aos_shell_t* shell, runtimedata_t* rdata, AosShellChannel* channel)
 {
   aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
   aosDbgCheck(channel != NULL);
 
   // local variables
-  aos_shellaction_t action = AOS_SHELL_ACTION_NONE;
+  size_t bytes = 0;
   char c;
   special_key_t key;
-  int nchars = 0;
-  bool exec = false;
+  action_t action;
 
   // read character by character from the channel
   while (chnReadTimeout(channel, (uint8_t*)&c, 1, TIME_IMMEDIATE)) {
-    key = KEY_UNKNOWN;
+    // increment byte counter
+    ++bytes;
 
-    // drop any input after an execution request was detected
-    if (exec) {
+    // drop any further input after an execution request was detected
+    if (rdata->lastaction == ACTION_EXECUTE && bytes > 1) {
       continue;
     }
 
-    // incremet character counter
-    ++nchars;
-
-    // parse escape sequence
-    if (strlen(shell->inputdata.escseq) > 0) {
-      shell->inputdata.escseq[strlen(shell->inputdata.escseq)] = c;
-      key = _interpreteEscapeSequence(shell->inputdata.escseq);
-      switch (key) {
-        case KEY_AMBIGUOUS:
-          // read next byte to resolve ambiguity
-          continue;
-        case KEY_UNKNOWN:
-          // do nothing here, but handle the unknown sequence below
-          break;
-        default:
-          // reset the sequence variable and buffer
-          memset(shell->inputdata.escseq, '\0', sizeof(shell->inputdata.escseq)*sizeof(shell->inputdata.escseq[0]));
-          break;
+    // try to interprete escape sequence
+    {
+      // set default
+      key = KEY_UNKNOWN;
+      // only interprete, if there is an escape sequence at all
+      const size_t escl = strlen(rdata->input.escseq);
+      if (escl > 0) {
+        // append and 'consume' character
+        rdata->input.escseq[escl] = c;
+        c = '\0';
+        // try to interprete sequence
+        key = _interpreteEscapeSequence(rdata->input.escseq);
+        switch (key) {
+          // ambiguous key due to incomplete sequence
+          case KEY_AMBIGUOUS:
+            // read next byte to resolve ambiguity
+            continue;
+          // an unknown sequence has been encountered
+          case KEY_UNKNOWN:
+            // increment number of inputs but handle this unknown sequence below
+            break;
+          // a key was identified successfully
+          default:
+            // reset the sequence buffer
+            memset(rdata->input.escseq, '\0', AOS_SHELL_ESCSEQUENCE_LENGTH * sizeof(char));
+            break;
+        }
       }
     }
 
-    /* interprete keys or character */
-    {
-      // default
-      action = AOS_SHELL_ACTION_NONE;
+    /*
+     * Derive action to be executed from keypress.
+     * This step handles all sanity checks, so any required prerequisites for the selected action are fulfilled.
+     */
+    // set default
+    action = ACTION_NONE;
+    // if there is no escape sequence pending
+    if (rdata->input.escseq[0] == '\0') {
 
       // printable character
-      if (key == KEY_UNKNOWN && strlen(shell->inputdata.escseq) == 0 && c >= '\x20' && c <= '\x7E') {
-        action = AOS_SHELL_ACTION_READCHAR;
+      if (c >= '\x20' && c <= '\x7E') {
+        action = ACTION_READCHAR;
       }
 
       // tab key or character
-      else if (key == KEY_TAB || c == '\x09') {
+      else if (c == '\x09' || key == KEY_TAB) {
         /*
          * pressing tab once applies auto fill
-         * pressing tab a second time prints suggestions
+         * pressing tab a second time (or more) prints suggestions
          */
-        if (shell->inputdata.lastaction == AOS_SHELL_ACTION_AUTOFILL || shell->inputdata.lastaction == AOS_SHELL_ACTION_SUGGEST) {
-          action = AOS_SHELL_ACTION_SUGGEST;
+        if (rdata->lastaction == ACTION_AUTOCOMPLETE || rdata->lastaction == ACTION_SUGGEST) {
+          action = ACTION_SUGGEST;
         } else {
-          action = AOS_SHELL_ACTION_AUTOFILL;
+          action = ACTION_AUTOCOMPLETE;
         }
       }
 
-      // INS key
-      else if (key == KEY_INSERT) {
-        action = AOS_SHELL_ACTION_INSERTTOGGLE;
-      }
-
-      // DEL key or character
-      else if (key == KEY_DELETE || c == '\x7F') {
-        // ignore if cursor is at very right
-        if (shell->inputdata.cursorpos < shell->inputdata.lineend) {
-          action = AOS_SHELL_ACTION_DELETEFORWARD;
-        }
+      // carriage return ('\r') or line feed ('\n') character
+      else if (c == '\x0D' || c == '\x0A') {
+        action = ACTION_EXECUTE;
       }
 
       // backspace key or character
-      else if (key == KEY_BACKSPACE || c == '\x08') {
+      else if (c == '\x08' || key == KEY_BACKSPACE) {
         // ignore if cursor is at very left
-        if (shell->inputdata.cursorpos > 0) {
-          action = AOS_SHELL_ACTION_DELETEBACKWARD;
+        if (rdata->input.cursorpos > 0) {
+          action = ACTION_DELETEBACKWARD;
         }
       }
 
-      // 'page up', 'arrow up', or key or CTRL + 'arrow up' key combination
-      else if (key == KEY_PAGE_UP || key == KEY_ARROW_UP || key == KEY_CTRL_ARROW_UP) {
-        // ignore if there was some input
-        if (shell->inputdata.noinput) {
-          action = AOS_SHELL_ACTION_RECALLLAST;
+      // DEL key or character
+      else if (c == '\x7F' || key == KEY_DELETE) {
+        // ignore if cursor is at very right
+        if (rdata->input.cursorpos < rdata->input.length) {
+          action = ACTION_DELETEFORWARD;
         }
       }
 
-      // 'page down' key, 'arrow down' key, 'end of test' character or 'end of transmission' character, or CTRL + 'arrow down' key combination
-      else if (key == KEY_PAGE_DOWN || key == KEY_ARROW_DOWN || c == '\x03' || c == '\x03' || key == KEY_CTRL_ARROW_DOWN) {
-        // ignore if line is empty
-        if (shell->inputdata.lineend > 0) {
-          action = AOS_SHELL_ACTION_CLEAR;
+      // 'arrow up' key
+      else if (key == KEY_ARROWUP) {
+        // recall previous input from history only if
+        // not the oldest entry is already selected and
+        // the previous entry has been set.
+        if (rdata->buffer.selected < shell->input.nentries &&
+            (_getRelativeEntry(shell, rdata, rdata->buffer.selected))[0] != INBUF_INIT_CHAR) {
+          action = ACTION_RECALLPREVIOUS;
         }
       }
 
-      // 'home' key
-      else if (key == KEY_HOME) {
-        // ignore if cursor is very left
-        if (shell->inputdata.cursorpos > 0) {
-          action = AOS_SHELL_ACTION_CURSOR2START;
+      // 'arrow down' key
+      else if (key == KEY_ARROWDOWN) {
+        // clear the line if
+        // no historic entry is selected or
+        // the most recent entry is selected, but the current one is occupied by a moodfied version of a historic entry
+        if ((rdata->buffer.selected == 1) ||
+            (rdata->buffer.selected == 2 && rdata->buffer.edited > 1)) {
+          action = ACTION_CLEAR;
         }
-      }
-
-      // 'end' key
-      else if (key == KEY_END) {
-        // ignore if cursos is very right
-        if (shell->inputdata.cursorpos < shell->inputdata.lineend) {
-          action = AOS_SHELL_ACTION_CURSOR2END;
+        // if a historic entry is selected, recall the next input from history
+        else if (rdata->buffer.selected > 1) {
+          action = ACTION_RECALLNEXT;
         }
       }
 
       // 'arrow left' key
-      else if (key == KEY_ARROW_LEFT) {
+      else if (key == KEY_ARROWLEFT) {
         // ignore if cursor is very left
-        if (shell->inputdata.cursorpos > 0) {
-          action = AOS_SHELL_ACTION_CURSORLEFT;
+        if (rdata->input.cursorpos > 0) {
+          action = ACTION_CURSORLEFT;
         }
       }
 
       // 'arrow right' key
-      else if (key == KEY_ARROW_RIGHT) {
+      else if (key == KEY_ARROWRIGHT) {
         // ignore if cursor is very right
-        if (shell->inputdata.cursorpos < shell->inputdata.lineend) {
-          action = AOS_SHELL_ACTION_CURSORRIGHT;
+        if (rdata->input.cursorpos < rdata->input.length) {
+          action = ACTION_CURSORRIGHT;
+        }
+      }
+
+      // CTRL + 'arrow up' key combination or 'page up' key
+      else if (key == KEY_CTRL_ARROWUP || key == KEY_PAGEUP) {
+        // recall oldest input from history only if
+        // not the oldest entry is already selected and
+        // there is at least one history entry set
+        if (rdata->buffer.selected < shell->input.nentries &&
+            (_getRelativeEntry(shell, rdata, (rdata->buffer.selected > 0) ? 1 : 0))[0] != INBUF_INIT_CHAR) {
+          action = ACTION_RECALLOLDEST;
+        }
+      }
+
+      // CTRL + 'arrow down' key combination or 'page down' key
+      else if (key == KEY_CTRL_ARROWDOWN || key == KEY_PAGEDOWN) {
+        // clear the line if
+        // no historic entry is selected or
+        // the most recent entry is selected, but the current one is occupied by a moodfied version of a historic entry
+        if ((rdata->buffer.selected == 1) ||
+            (rdata->buffer.selected > 1 && rdata->buffer.edited > 1)) {
+          action = ACTION_CLEAR;
+        }
+        // if a historic entry is selected, reset to the current input
+        else if (rdata->buffer.selected > 1) {
+          action = ACTION_RECALLCURRENT;
         }
       }
 
       // CTRL + 'arrow left' key combination
-      else if (key == KEY_CTRL_ARROW_LEFT) {
+      else if (key == KEY_CTRL_ARROWLEFT) {
         // ignore if cursor is very left
-        if (shell->inputdata.cursorpos > 0) {
-          action = AOS_SHELL_ACTION_CURSORWORDLEFT;
+        if (rdata->input.cursorpos > 0) {
+          action = ACTION_CURSORWORDLEFT;
         }
       }
 
       // CTRL + 'arrow right' key combination
-      else if (key == KEY_CTRL_ARROW_RIGHT) {
+      else if (key == KEY_CTRL_ARROWRIGHT) {
         // ignore if cursor is very right
-        if (shell->inputdata.cursorpos < shell->inputdata.lineend) {
-          action = AOS_SHELL_ACTION_CURSORWORDRIGHT;
+        if (rdata->input.cursorpos < rdata->input.length) {
+          action = ACTION_CURSORWORDRIGHT;
         }
       }
 
-      // carriage return ('\r') or line feed ('\n') character
-      else if (c == '\x0D' || c == '\x0A') {
-        action = AOS_SHELL_ACTION_EXECUTE;
+      // 'end' key
+      else if (key == KEY_END) {
+        // ignore if cursos is very right
+        if (rdata->input.cursorpos < rdata->input.length) {
+          action = ACTION_CURSOR2END;
+        }
       }
 
-      // ESC key or [ESCAPE] character
-      else if (key == KEY_ESCAPE || c == '\x1B') {
-        action = AOS_SHELL_ACTION_ESCSTART;
+      // 'home' key
+      else if (key == KEY_HOME) {
+        // ignore if cursor is very left
+        if (rdata->input.cursorpos > 0) {
+          action = ACTION_CURSOR2START;
+        }
       }
 
-      // unknown escape sequence
-      else if (key == KEY_UNKNOWN && strlen(shell->inputdata.escseq) > 0) {
-        action = AOS_SHELL_ACTION_PRINTUNKNOWNSEQUENCE;
+      // CTRL + C key combination
+      else if (c == '\x03' || key == KEY_CTRL_C) {
+        action = ACTION_RESET;
+      }
+
+      // INS key
+      else if (key == KEY_INSERT) {
+        action = ACTION_INSERTTOGGLE;
+      }
+
+      // ESC key or [ESCAPE] character
+      else if (c == '\x1B' || key == KEY_ESCAPE) {
+        action = ACTION_ESCSTART;
       }
     }
+    // ongoing escape sequence or interpretation failed
+    else /* if (rdata->input.escseq[0] != '\0') */ {
+      // unknown escape sequence (interpretation failed)
+      if (key == KEY_UNKNOWN) {
+        action = ACTION_PRINTUNKNOWNSEQUENCE;
+      }
+    } /* end of action selection */
 
-    /* handle function */
+    /*
+     * execute action
+     */
     switch (action) {
-      case AOS_SHELL_ACTION_READCHAR:
+      case ACTION_NONE:
+      {
+        // do nothing (ignore input) and read next byte
+        break;
+      }
+
+      case ACTION_READCHAR:
       {
-        if (_readChar(shell, c) == 0) {
+        char* line = _prepare4Modification(shell, rdata);
+        if (_printChar(shell, rdata, c) == 0) {
           // line is full
-          _moveCursor(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
+          _moveCursor(shell, line, rdata->input.cursorpos, rdata->input.length);
           chprintf((BaseSequentialStream*)&shell->stream, "\n\tmaximum line width reached\n");
           _printPrompt(shell);
-          _printLine(shell, 0, shell->inputdata.lineend);
-          _moveCursor(shell, shell->inputdata.lineend, shell->inputdata.cursorpos);
+          _printString(shell, line, 0, rdata->input.length);
+          _moveCursor(shell, line, rdata->input.length, rdata->input.cursorpos);
         }
         break;
       }
 
-      case AOS_SHELL_ACTION_AUTOFILL:
+      case ACTION_AUTOCOMPLETE:
       {
-        const char* fill = shell->input.line;
-        size_t cmatch = shell->inputdata.cursorpos;
+        // local variables
+        char* line = _getVisualisedEntry(shell, rdata);
+        const char* fill = line;
+        size_t cmatch = rdata->input.cursorpos;
         charmatch_t matchlevel = CHAR_MATCH_NOT;
         size_t n;
-        // iterate through command list
-        for (aos_shellcommand_t* cmd = shell->commands; cmd != NULL; cmd = cmd->next) {
-          // compare current match with command
-          n = cmatch;
-          charmatch_t mlvl = CHAR_MATCH_NOT;
-          _strccmp(fill, cmd->name, shell->config & AOS_SHELL_CONFIG_MATCH_CASE, (n == 0) ? NULL : &n, &mlvl);
-          const int cmp = (n < cmatch) ?
-                            ((int)n - (int)cmatch) :
-                            (cmd->name[n] != '\0') ?
-                              (int)strlen(cmd->name) - (int)n :
-                              0;
-          // if an exact match was found
-          if ((size_t)((int)cmatch + cmp) == shell->inputdata.cursorpos) {
-            cmatch = shell->inputdata.cursorpos;
-            fill = cmd->name;
-            // break the loop only if there are no case mismatches with the input
-            n = shell->inputdata.cursorpos;
-            _strccmp(fill, shell->input.line, false, &n, &mlvl);
-            if (mlvl == CHAR_MATCH_CASE) {
-              break;
-            }
-          }
-          // if a not exact match was found
-          else if ((size_t)((int)cmatch + cmp) > shell->inputdata.cursorpos) {
-            // if this is the first one
-            if (fill == shell->input.line) {
-              cmatch = (size_t)((int)cmatch + cmp);
+
+        // only execute autofill if the line is valid
+        if (line) {
+          _prepare4Modification(shell, rdata);
+
+          // iterate through command list
+          for (aos_shellcommand_t* cmd = shell->commands; cmd != NULL; cmd = cmd->next) {
+            // compare current match with command
+            n = cmatch;
+            charmatch_t mlvl = CHAR_MATCH_NOT;
+            _strccmp(fill, cmd->name, shell->config & AOS_SHELL_CONFIG_MATCH_CASE, (n == 0) ? NULL : &n, &mlvl);
+            const int cmp = (n < cmatch) ?
+                  ((int)n - (int)cmatch) :
+                  (cmd->name[n] != '\0') ?
+                    (int)strlen(cmd->name) - (int)n :
+                    0;
+            // if an exact match was found
+            if ((size_t)((int)cmatch + cmp) == rdata->input.cursorpos) {
+              cmatch = rdata->input.cursorpos;
               fill = cmd->name;
+              // break the loop only if there are no case mismatches with the input
+              n = rdata->input.cursorpos;
+              _strccmp(fill, line, false, &n, &mlvl);
+              if (mlvl == CHAR_MATCH_CASE) {
+                break;
+              }
             }
-            // if this is a worse one
-            else if ((cmp < 0) || (cmp == 0 && mlvl == CHAR_MATCH_CASE)) {
-              cmatch = (size_t)((int)cmatch + cmp);
+            // if a not exact match was found
+            else if ((size_t)((int)cmatch + cmp) > rdata->input.cursorpos) {
+              // if this is the first one
+              if (fill == line) {
+                cmatch = (size_t)((int)cmatch + cmp);
+                fill = cmd->name;
+              }
+              // if this is a worse one
+              else if ((cmp < 0) || (cmp == 0 && mlvl == CHAR_MATCH_CASE)) {
+                cmatch = (size_t)((int)cmatch + cmp);
+              }
             }
+            // non matching commands are ignored
+            else {}
           }
-          // non matching commands are ignored
-          else {}
-        }
-        // evaluate if there are case mismatches
-        n = cmatch;
-        _strccmp(shell->input.line, fill, shell->config & AOS_SHELL_CONFIG_MATCH_CASE, &n, &matchlevel);
-        // print the auto fill if any
-        if (cmatch > shell->inputdata.cursorpos || (cmatch == shell->inputdata.cursorpos && matchlevel == CHAR_MATCH_NCASE)) {
-          shell->inputdata.noinput = false;
-          // limit auto fill so it will not overflow the line width
-          if (shell->inputdata.lineend + (cmatch - shell->inputdata.cursorpos) > shell->input.size) {
-            cmatch = shell->input.size - shell->inputdata.lineend + shell->inputdata.cursorpos;
-          }
-          // move trailing memory further in the line
-          memmove(&(shell->input.line[cmatch]), &(shell->input.line[shell->inputdata.cursorpos]), shell->inputdata.lineend - shell->inputdata.cursorpos);
-          shell->inputdata.lineend += cmatch - shell->inputdata.cursorpos;
-          // if there was no incorrect case when matching
-          if (matchlevel == CHAR_MATCH_CASE) {
-            // insert fill command name to line
-            memcpy(&(shell->input.line[shell->inputdata.cursorpos]), &(fill[shell->inputdata.cursorpos]), cmatch - shell->inputdata.cursorpos);
-            // print the output
-            _printLine(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
-          } else {
-            // overwrite line with fill command name
-            memcpy(shell->input.line, fill, cmatch);
-            // reprint the whole line
-            _moveCursor(shell, shell->inputdata.cursorpos, 0);
-            _printLine(shell, 0, shell->inputdata.lineend);
+
+          // evaluate if there are case mismatches
+          n = cmatch;
+          _strccmp(line, fill, shell->config & AOS_SHELL_CONFIG_MATCH_CASE, &n, &matchlevel);
+          // print the auto fill if any
+          if (cmatch > rdata->input.cursorpos || (cmatch == rdata->input.cursorpos && matchlevel == CHAR_MATCH_NCASE)) {
+            // limit auto fill so it will not overflow the line width
+            if (rdata->input.length + (cmatch - rdata->input.cursorpos) > shell->input.linewidth) {
+              cmatch = shell->input.linewidth - rdata->input.length + rdata->input.cursorpos;
+            }
+            // move trailing memory further in the line
+            memmove(&line[cmatch], &line[rdata->input.cursorpos], (rdata->input.length - rdata->input.cursorpos) * sizeof(char));
+            rdata->input.length += cmatch - rdata->input.cursorpos;
+            // if there was no incorrect case when matching
+            if (matchlevel == CHAR_MATCH_CASE) {
+              // insert fill command name to line
+              memcpy(&line[rdata->input.cursorpos], &fill[rdata->input.cursorpos], (cmatch - rdata->input.cursorpos) * sizeof(char));
+              // print the output
+              _printString(shell, line, rdata->input.cursorpos, rdata->input.length);
+            } else {
+              // overwrite line with fill command name
+              memcpy(line, fill, cmatch * sizeof(char));
+              // reprint the whole line
+              _moveCursor(shell, line, rdata->input.cursorpos, 0);
+              _printString(shell, line, 0, rdata->input.length);
+            }
+            // move cursor to the end of the matching sequence
+            rdata->input.cursorpos = cmatch;
+            _moveCursor(shell, line, rdata->input.length, rdata->input.cursorpos);
           }
-          // move cursor to the end of the matching sequence
-          shell->inputdata.cursorpos = cmatch;
-          _moveCursor(shell, shell->inputdata.lineend, shell->inputdata.cursorpos);
         }
         break;
       }
 
-      case AOS_SHELL_ACTION_SUGGEST:
+      case ACTION_SUGGEST:
       {
+        // local variables
+        const char* line = _getVisualisedEntry(shell, rdata);
         unsigned int matches = 0;
+
         // iterate through command list
         for (aos_shellcommand_t* cmd = shell->commands; cmd != NULL; cmd = cmd->next) {
-          // compare line content with command, excpet if cursorpos=0
-          size_t i = shell->inputdata.cursorpos;
-          if (shell->inputdata.cursorpos > 0) {
-            _strccmp(shell->input.line, cmd->name, true, &i, NULL);
+          // compare line content with command, except if cursorpos is 0
+          size_t i = rdata->input.cursorpos;
+          if (rdata->input.cursorpos > 0) {
+            _strccmp(line, cmd->name, true, &i, NULL);
           }
-          const int cmp = (i < shell->inputdata.cursorpos) ?
-                            (int)(i - shell->inputdata.cursorpos) :
-                            (cmd->name[i] != '\0') ?
-                              (int)strlen(cmd->name) - (int)i :
-                              0;
+          const int cmp = (i < rdata->input.cursorpos) ?
+                ((int)i - (int)rdata->input.cursorpos) :
+                (cmd->name[i] != '\0') ?
+                  (int)strlen(cmd->name) - (int)i :
+                  0;
           // if a match was found
           if (cmp > 0) {
             // if this is the first one
             if (matches == 0) {
-              _moveCursor(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
+              _moveCursor(shell, line, rdata->input.cursorpos, rdata->input.length);
               streamPut(&shell->stream, '\n');
             }
             // print the command
